#ifndef _MCDUMP_H_
#define _MCDUMP_H_

#ifndef PS2SDK
/* SCE's headers */
#include <kernel.h>
#include <stdio.h>
#include <string.h>
#include <sys/fcntl.h>

#else
/* PS2SDK headers */
#include <intrman.h>
#include <iomanX.h>
#include <loadcore.h>
#include <stdio.h>
#include <sysclib.h>
#include <sysmem.h>
#include <thsemap.h>

#endif

#ifdef PS2SDK
typedef unsigned char  u_char;
typedef unsigned int   u_int;
typedef unsigned short u_short;
typedef unsigned long  u_long;
#endif

#define VOIDPTR(x)                    (*(void **)&(x))

/* memory card error codes */
#define sceMcResSucceed               (0)
#define sceMcResChangedCard           (-1)
#define sceMcResNoFormat              (-2)
#define sceMcResFullDevice            (-3)
#define sceMcResNoEntry               (-4)
#define sceMcResDeniedPermit          (-5)
#define sceMcResNotEmpty              (-6)
#define sceMcResUpLimitHandle         (-7)
#define sceMcResFailReplace           (-8)

/* memory card types */
#define sceMcTypeNoCard               (0)
#define sceMcTypePS1                  (1)
#define sceMcTypePS2                  (2)
#define sceMcTypePDA                  (3)

int main(int argc, char *argv[]);

#ifndef PS2SDK
#define Start                         start
#else
#define Start                         _start
#endif

#ifdef PS2SDK
#define NO_RESIDENT_END               MODULE_NO_RESIDENT_END
#define SMEM_Low                      ALLOC_FIRST
#define LibInfo                       iop_library_t
#endif

typedef
struct _McSpec
{
 u_short  PageSize; /* Page size in bytes (user data only) */
 u_short  BlockSize; /* Block size in pages */
 u_int    CardSize; /* Total number of pages */
} McSpec;

#define PS1_CARDINFO_SIGN           0x3149434D
#define PS2_CARDINFO_SIGN           0x3249434D

typedef
struct _CardInfo
{
 u_int    sign;
 McSpec   spec;
 u_int    flag;
} CardInfo;


/* LOADCORE's: */
void *QueryLibraryEntryTable(LibInfo *lib);

/* internal routines */
void *GetLibraryEntry(char *libname, int version, int entryno);
int McGetDefSpec1(int port, int slot, u_short *pagesize, u_short *blocksize, u_int *cardsize, u_char *cardflags);
int McGetDefSpec2(int port, int slot, u_short *pagesize, u_short *blocksize, u_int *cardsize, u_char *cardflags);
void *SysAlloc(u_long size);
int SysFree(void *area);
void LockMcman();
void FreeMcman();

#endif
